// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.4.0
// - protoc             (unknown)
// source: vault/v0alpha/service.proto

package v0alpha

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.62.0 or later.
const _ = grpc.SupportPackageIsVersion8

const (
	VaultService_CreatePassword_FullMethodName        = "/vault.v0alpha.VaultService/CreatePassword"
	VaultService_SavePassword_FullMethodName          = "/vault.v0alpha.VaultService/SavePassword"
	VaultService_SaveK4LPassword_FullMethodName       = "/vault.v0alpha.VaultService/SaveK4LPassword"
	VaultService_FindPasswords_FullMethodName         = "/vault.v0alpha.VaultService/FindPasswords"
	VaultService_FindMe2Passwords_FullMethodName      = "/vault.v0alpha.VaultService/FindMe2Passwords"
	VaultService_FindPasswordById_FullMethodName      = "/vault.v0alpha.VaultService/FindPasswordById"
	VaultService_FindMe2PasswordById_FullMethodName   = "/vault.v0alpha.VaultService/FindMe2PasswordById"
	VaultService_DeletePasswordById_FullMethodName    = "/vault.v0alpha.VaultService/DeletePasswordById"
	VaultService_DeleteMe2PasswordById_FullMethodName = "/vault.v0alpha.VaultService/DeleteMe2PasswordById"
)

// VaultServiceClient is the client API for VaultService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// VaultService should be used only as a local machine service.
// The service itself is not responsible for data encryption,
// and decryption as it only runs on the local machine. However,
// all vault entries should be encrypted before synchronizing
// with the remote database.
type VaultServiceClient interface {
	// CreatePassword creates a new password,
	// with an automatically generated key, if necessary.
	CreatePassword(ctx context.Context, in *CreatePasswordRequest, opts ...grpc.CallOption) (*CreatePasswordResponse, error)
	// SavePassword overwrites a given password by its primary key.
	// All fields will be written, even the empty ones.
	// E.g. if you would attempt to save an entry with an empty
	// password, it will be done accordingly.
	SavePassword(ctx context.Context, in *SavePasswordRequest, opts ...grpc.CallOption) (*SavePasswordResponse, error)
	// SaveK4LPassword is the same as SavePassword, but it does not
	// simply overwrites the previous record. Instead, if enabled, it will
	// save a new record, marking the old record as a parent, and soft deleting
	// the parent record.
	SaveK4LPassword(ctx context.Context, in *SavePasswordRequest, opts ...grpc.CallOption) (*SavePasswordResponse, error)
	// FindPasswords should fetch all passwords from underlying data storage.
	FindPasswords(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*FindPasswordsResponse, error)
	// FindMe2Passwords should fetch only the password with the required id.
	FindMe2Passwords(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*FindPasswordsResponse, error)
	// FindPasswordById should fetch only the password with the required id,
	// including soft deleted records too.
	FindPasswordById(ctx context.Context, in *FindPasswordByIdRequest, opts ...grpc.CallOption) (*FindPasswordByIdResponse, error)
	// FindMe2PasswordById should fetch only the password with the required id,
	// including soft deleted records too.
	FindMe2PasswordById(ctx context.Context, in *FindPasswordByIdRequest, opts ...grpc.CallOption) (*FindPasswordByIdResponse, error)
	// DeletePasswordById should soft delete the password described by the request,
	// if soft deletion is enabled.
	DeletePasswordById(ctx context.Context, in *DeletePasswordByIdRequest, opts ...grpc.CallOption) (*DeletePasswordByIdResponse, error)
	// DeleteMe2PasswordById should hard delete the password described by the request.
	DeleteMe2PasswordById(ctx context.Context, in *DeletePasswordByIdRequest, opts ...grpc.CallOption) (*DeletePasswordByIdResponse, error)
}

type vaultServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewVaultServiceClient(cc grpc.ClientConnInterface) VaultServiceClient {
	return &vaultServiceClient{cc}
}

func (c *vaultServiceClient) CreatePassword(ctx context.Context, in *CreatePasswordRequest, opts ...grpc.CallOption) (*CreatePasswordResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(CreatePasswordResponse)
	err := c.cc.Invoke(ctx, VaultService_CreatePassword_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) SavePassword(ctx context.Context, in *SavePasswordRequest, opts ...grpc.CallOption) (*SavePasswordResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(SavePasswordResponse)
	err := c.cc.Invoke(ctx, VaultService_SavePassword_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) SaveK4LPassword(ctx context.Context, in *SavePasswordRequest, opts ...grpc.CallOption) (*SavePasswordResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(SavePasswordResponse)
	err := c.cc.Invoke(ctx, VaultService_SaveK4LPassword_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) FindPasswords(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*FindPasswordsResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(FindPasswordsResponse)
	err := c.cc.Invoke(ctx, VaultService_FindPasswords_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) FindMe2Passwords(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*FindPasswordsResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(FindPasswordsResponse)
	err := c.cc.Invoke(ctx, VaultService_FindMe2Passwords_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) FindPasswordById(ctx context.Context, in *FindPasswordByIdRequest, opts ...grpc.CallOption) (*FindPasswordByIdResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(FindPasswordByIdResponse)
	err := c.cc.Invoke(ctx, VaultService_FindPasswordById_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) FindMe2PasswordById(ctx context.Context, in *FindPasswordByIdRequest, opts ...grpc.CallOption) (*FindPasswordByIdResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(FindPasswordByIdResponse)
	err := c.cc.Invoke(ctx, VaultService_FindMe2PasswordById_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) DeletePasswordById(ctx context.Context, in *DeletePasswordByIdRequest, opts ...grpc.CallOption) (*DeletePasswordByIdResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(DeletePasswordByIdResponse)
	err := c.cc.Invoke(ctx, VaultService_DeletePasswordById_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vaultServiceClient) DeleteMe2PasswordById(ctx context.Context, in *DeletePasswordByIdRequest, opts ...grpc.CallOption) (*DeletePasswordByIdResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(DeletePasswordByIdResponse)
	err := c.cc.Invoke(ctx, VaultService_DeleteMe2PasswordById_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// VaultServiceServer is the server API for VaultService service.
// All implementations must embed UnimplementedVaultServiceServer
// for forward compatibility
//
// VaultService should be used only as a local machine service.
// The service itself is not responsible for data encryption,
// and decryption as it only runs on the local machine. However,
// all vault entries should be encrypted before synchronizing
// with the remote database.
type VaultServiceServer interface {
	// CreatePassword creates a new password,
	// with an automatically generated key, if necessary.
	CreatePassword(context.Context, *CreatePasswordRequest) (*CreatePasswordResponse, error)
	// SavePassword overwrites a given password by its primary key.
	// All fields will be written, even the empty ones.
	// E.g. if you would attempt to save an entry with an empty
	// password, it will be done accordingly.
	SavePassword(context.Context, *SavePasswordRequest) (*SavePasswordResponse, error)
	// SaveK4LPassword is the same as SavePassword, but it does not
	// simply overwrites the previous record. Instead, if enabled, it will
	// save a new record, marking the old record as a parent, and soft deleting
	// the parent record.
	SaveK4LPassword(context.Context, *SavePasswordRequest) (*SavePasswordResponse, error)
	// FindPasswords should fetch all passwords from underlying data storage.
	FindPasswords(context.Context, *emptypb.Empty) (*FindPasswordsResponse, error)
	// FindMe2Passwords should fetch only the password with the required id.
	FindMe2Passwords(context.Context, *emptypb.Empty) (*FindPasswordsResponse, error)
	// FindPasswordById should fetch only the password with the required id,
	// including soft deleted records too.
	FindPasswordById(context.Context, *FindPasswordByIdRequest) (*FindPasswordByIdResponse, error)
	// FindMe2PasswordById should fetch only the password with the required id,
	// including soft deleted records too.
	FindMe2PasswordById(context.Context, *FindPasswordByIdRequest) (*FindPasswordByIdResponse, error)
	// DeletePasswordById should soft delete the password described by the request,
	// if soft deletion is enabled.
	DeletePasswordById(context.Context, *DeletePasswordByIdRequest) (*DeletePasswordByIdResponse, error)
	// DeleteMe2PasswordById should hard delete the password described by the request.
	DeleteMe2PasswordById(context.Context, *DeletePasswordByIdRequest) (*DeletePasswordByIdResponse, error)
	mustEmbedUnimplementedVaultServiceServer()
}

// UnimplementedVaultServiceServer must be embedded to have forward compatible implementations.
type UnimplementedVaultServiceServer struct {
}

func (UnimplementedVaultServiceServer) CreatePassword(context.Context, *CreatePasswordRequest) (*CreatePasswordResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreatePassword not implemented")
}
func (UnimplementedVaultServiceServer) SavePassword(context.Context, *SavePasswordRequest) (*SavePasswordResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SavePassword not implemented")
}
func (UnimplementedVaultServiceServer) SaveK4LPassword(context.Context, *SavePasswordRequest) (*SavePasswordResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SaveK4LPassword not implemented")
}
func (UnimplementedVaultServiceServer) FindPasswords(context.Context, *emptypb.Empty) (*FindPasswordsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindPasswords not implemented")
}
func (UnimplementedVaultServiceServer) FindMe2Passwords(context.Context, *emptypb.Empty) (*FindPasswordsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindMe2Passwords not implemented")
}
func (UnimplementedVaultServiceServer) FindPasswordById(context.Context, *FindPasswordByIdRequest) (*FindPasswordByIdResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindPasswordById not implemented")
}
func (UnimplementedVaultServiceServer) FindMe2PasswordById(context.Context, *FindPasswordByIdRequest) (*FindPasswordByIdResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindMe2PasswordById not implemented")
}
func (UnimplementedVaultServiceServer) DeletePasswordById(context.Context, *DeletePasswordByIdRequest) (*DeletePasswordByIdResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeletePasswordById not implemented")
}
func (UnimplementedVaultServiceServer) DeleteMe2PasswordById(context.Context, *DeletePasswordByIdRequest) (*DeletePasswordByIdResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteMe2PasswordById not implemented")
}
func (UnimplementedVaultServiceServer) mustEmbedUnimplementedVaultServiceServer() {}

// UnsafeVaultServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to VaultServiceServer will
// result in compilation errors.
type UnsafeVaultServiceServer interface {
	mustEmbedUnimplementedVaultServiceServer()
}

func RegisterVaultServiceServer(s grpc.ServiceRegistrar, srv VaultServiceServer) {
	s.RegisterService(&VaultService_ServiceDesc, srv)
}

func _VaultService_CreatePassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreatePasswordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).CreatePassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_CreatePassword_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).CreatePassword(ctx, req.(*CreatePasswordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_SavePassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SavePasswordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).SavePassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_SavePassword_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).SavePassword(ctx, req.(*SavePasswordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_SaveK4LPassword_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(SavePasswordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).SaveK4LPassword(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_SaveK4LPassword_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).SaveK4LPassword(ctx, req.(*SavePasswordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_FindPasswords_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).FindPasswords(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_FindPasswords_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).FindPasswords(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_FindMe2Passwords_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).FindMe2Passwords(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_FindMe2Passwords_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).FindMe2Passwords(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_FindPasswordById_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FindPasswordByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).FindPasswordById(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_FindPasswordById_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).FindPasswordById(ctx, req.(*FindPasswordByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_FindMe2PasswordById_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(FindPasswordByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).FindMe2PasswordById(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_FindMe2PasswordById_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).FindMe2PasswordById(ctx, req.(*FindPasswordByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_DeletePasswordById_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeletePasswordByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).DeletePasswordById(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_DeletePasswordById_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).DeletePasswordById(ctx, req.(*DeletePasswordByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _VaultService_DeleteMe2PasswordById_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeletePasswordByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VaultServiceServer).DeleteMe2PasswordById(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: VaultService_DeleteMe2PasswordById_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VaultServiceServer).DeleteMe2PasswordById(ctx, req.(*DeletePasswordByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// VaultService_ServiceDesc is the grpc.ServiceDesc for VaultService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var VaultService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vault.v0alpha.VaultService",
	HandlerType: (*VaultServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreatePassword",
			Handler:    _VaultService_CreatePassword_Handler,
		},
		{
			MethodName: "SavePassword",
			Handler:    _VaultService_SavePassword_Handler,
		},
		{
			MethodName: "SaveK4LPassword",
			Handler:    _VaultService_SaveK4LPassword_Handler,
		},
		{
			MethodName: "FindPasswords",
			Handler:    _VaultService_FindPasswords_Handler,
		},
		{
			MethodName: "FindMe2Passwords",
			Handler:    _VaultService_FindMe2Passwords_Handler,
		},
		{
			MethodName: "FindPasswordById",
			Handler:    _VaultService_FindPasswordById_Handler,
		},
		{
			MethodName: "FindMe2PasswordById",
			Handler:    _VaultService_FindMe2PasswordById_Handler,
		},
		{
			MethodName: "DeletePasswordById",
			Handler:    _VaultService_DeletePasswordById_Handler,
		},
		{
			MethodName: "DeleteMe2PasswordById",
			Handler:    _VaultService_DeleteMe2PasswordById_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vault/v0alpha/service.proto",
}
